<?xml version='1.0'?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0"
                xmlns="http://www.w3.org/TR/REC-html40">

<!-- This is version 0.1 of an IPTC NewsML stylesheet produced by David Allen, MD IPTC to implement pruning and grafting on the NewsML tree using the Update element. Copyright 2000 IPTC-->
<!-- It has been tested with the xt parser from James Clark and the Saxon parser from  Michael Kay-->



<xsl:output method="xml" version="1.0" encoding="utf-8" doctype-public="newsml://IPTC/2000-07-06/NewsMLv1.0-Beta" doctype-system="NewsMLv1.0-Beta.dtd"/>

<xsl:variable name="root" select="/"/>

<xsl:template match="Update">
<xsl:for-each select="/NewsML/NewsItem">
<xsl:variable name="NIFile">
<xsl:call-template name="Catent">
<xsl:with-param name="NID" select="concat('newsml://',.//ProviderId,'/',.//DateId,'/',.//NewsItemId,'/',number(.//RevisionId)-1)"/>
</xsl:call-template>
</xsl:variable>
<xsl:for-each select="document($NIFile)">
<xsl:apply-templates mode="FCopy">
<xsl:with-param name="RevNo" select="$root//RevisionId"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:for-each>
</xsl:template>

<xsl:template match="*|@*" mode="FCopy">
<xsl:param name="RevNo"/>
<xsl:variable name="locrev" select="$RevNo"/>
<xsl:choose>
<xsl:when test="RevisionId">
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier">
<xsl:copy>
<xsl:copy-of select="@*"/>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/ProviderId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/DateId">
<xsl:copy-of select="."/>
</xsl:for-each>
<xsl:for-each select="/NewsML/NewsItem/Identification/NewsIdentifier/NewsItemId">
<xsl:copy-of select="."/>
</xsl:for-each>
</xsl:copy>
</xsl:for-each>
<xsl:element name="RevisionId" namespace="">
<xsl:copy-of select="@Duid"/>
<xsl:copy-of select="@Euid"/>
<xsl:attribute name="PreviousRevision">
<xsl:value-of select="($RevNo)-1"/>
</xsl:attribute>
<xsl:value-of select="$RevNo"/>
</xsl:element>
</xsl:when>
<xsl:otherwise>
<xsl:variable name="upact">
<xsl:if test="@Duid">
<xsl:call-template name="uptype">
<xsl:with-param name="eleid" select="@Duid"/>
</xsl:call-template>
</xsl:if>
<xsl:if test="not(@Duid)"/>
</xsl:variable>
<xsl:variable name="upins">
<xsl:if test="$upact">
<xsl:call-template name="updata">
<xsl:with-param name="eleid" select="@Duid"/>
</xsl:call-template>
</xsl:if>
<xsl:if test="not($upact)"/>
</xsl:variable>
<xsl:choose>
<xsl:when test="$upact='Delete'"/>
<xsl:when test="$upact='Replace'">
<xsl:copy-of select="$upins"/>
</xsl:when>
</xsl:choose>
<xsl:if test="$upact!='Delete'">
<xsl:if test="$upact!='Replace'">
<xsl:if test="$upact='InsertBefore'">
<xsl:copy-of select="$upins"/>
</xsl:if>
<xsl:copy>
<xsl:apply-templates select="@*" mode="FCopy"/>
<xsl:apply-templates mode="FCopy">
<xsl:with-param name="RevNo" select="$locrev"/>
</xsl:apply-templates>
</xsl:copy>
<xsl:if test="$upact='InsertAfter'">
<xsl:copy-of select="$upins"/>
</xsl:if>
</xsl:if>
</xsl:if>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="uptype">
<xsl:param name="eleid"/>
<xsl:for-each select="$root//Update">
<xsl:for-each select="*/@DuidRef">
<xsl:if test=".=$eleid">
<xsl:value-of select="name(parent::*)"/>
</xsl:if>
</xsl:for-each>
</xsl:for-each>
</xsl:template>

<xsl:template name="updata">
<xsl:param name="eleid"/>
<xsl:for-each select="$root//Update">
<xsl:for-each select="*/@DuidRef">
<xsl:if test=".=$eleid">
<xsl:for-each select="(parent::*)">
<xsl:apply-templates mode="copyins"/>
</xsl:for-each>
</xsl:if>
</xsl:for-each>
</xsl:for-each>
</xsl:template>



<xsl:template match="*|@*" mode="copyins">
<xsl:copy>
<xsl:apply-templates select="@*" mode="copyins"/>
<xsl:apply-templates mode="copyins"/>
</xsl:copy>
</xsl:template>


<xsl:template name="Catent">
<xsl:param name="NID"/>
<xsl:for-each select="document('NICatalog.xml')/Catalog/Entry">
<xsl:if test="$NID=@NIid">
<xsl:value-of select="@NIFile"/>
</xsl:if>
</xsl:for-each>
</xsl:template>


</xsl:stylesheet>























































